/*
  TextDisplay.cpp - Buffered alphanumeric display for a ST7565 based 12864 LCD.
  Thomas Baum, th.baum@online.de, 12.09.2014
*/

#include "TextDisplay.h"
#include "Display.h"
#include "Font.h"

void TextDisplay::init(byte contrast) {
  lcd = Display();
  lcd.init(contrast);
  lcd.clearDisplayRAM();
  lcd.setPageAddress(0);
  lcd.setColumnAddress(0);
}

void TextDisplay::print(const char* string) {
  
  int position = 0;
  while (string[position]) {
    char character = string[position];
    int position = character * CHARACTER_WIDTH;
    for (byte i=0; i<CHARACTER_WIDTH; i++) {
      lcd.writeData(pgm_read_byte(font7x5 + position++));
    }
    string++;
  }
}

