#include "Display.h"
#include "SPI.h"

//7x5 Font 0-9, A-F
const unsigned char hexFont [] = {
  0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00, 0x42, 0x7F, 0x40, 0x00, 0x42, 0x61, 0x51, 0x49, 0x46, 0x22,
  0x41, 0x49, 0x49, 0x36, 0x0C, 0x0B, 0x08, 0x7C, 0x08, 0x4F, 0x49, 0x49, 0x49, 0x31, 0x3E, 0x49,
  0x49, 0x49, 0x32, 0x01, 0x01, 0x71, 0x09, 0x07, 0x36, 0x49, 0x49, 0x49, 0x36, 0x26, 0x49, 0x49,
  0x49, 0x3E, 0x7E, 0x09, 0x09, 0x09, 0x7E, 0x7F, 0x49, 0x49, 0x49, 0x36, 0x3E, 0x41, 0x41, 0x41,
  0x22, 0x7F, 0x41, 0x41, 0x22, 0x1C, 0x7F, 0x49, 0x49, 0x49, 0x41, 0x7F, 0x09, 0x09, 0x09, 0x01
};

Display lcd = Display();

void setup() {
  lcd.init(20);
  lcd.clearDisplayRAM();
  lcd.setPageAddress(3);
  lcd.setColumnAddress(15);

  for (byte character = 0; character<16; character++) {    //for all characters
    byte position = character*5;                           //compute start position
    for (byte i=0; i < 5; i++) {                           //write 5 bytes
      lcd.writeData(hexFont[position++]);
    }
    lcd.writeData(0x00);                                   //write a blanc
  }
}

void loop() {
}

