#include "Display.h"
#include "SPI.h"
#include "Time.h"
#include "background.h"

char inputBuffer[20];
Display lcd = Display();

char* daysS[]={"Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"};
char* monthS[]={"Januar", "Februar", "Maerz", "April", "Mai", "Juni", 
"Juli", "August", "September", "Oktober", "November", "Dezember"};

void setup() {
  Serial.begin(9600);
  Serial.println("Set Date (Format: HHMMSSDDMMYYYY)");
  lcd.init(20);
}

void loop() {
  int i = 0;
  if (Serial.available() > 0) {
    memset(inputBuffer, 0, sizeof(inputBuffer));
    delay(50);
    while (Serial.available() > 0 && i < sizeof(inputBuffer) - 1) {
      inputBuffer[i] = Serial.read();
      i++;
    }
    inputBuffer[i] = 0;
    char hours[3] = {inputBuffer[0], inputBuffer[1], 0};
    char minutes[3] = {inputBuffer[2], inputBuffer[3], 0};
    char seconds[3] = {inputBuffer[4], inputBuffer[5], 0};
    char day[3] = {inputBuffer[6], inputBuffer[7], 0};
    char month[3] = {inputBuffer[8], inputBuffer[9], 0};
    char year[5] = {inputBuffer[10], inputBuffer[11], inputBuffer[12], inputBuffer[13], 0};
    
    setTime(atoi(hours), atoi(minutes), atoi(seconds), atoi(day), atoi(month), atoi(year));
  }
  
  lcd.clearVideoBuffer();
  lcd.drawBitmap(0, 0, 128, 64, watch);
  
  lcd.drawLine(31, 32, 31+(int)(17*cos((hour()%12*30+minute()/2.0-90) *  M_PI / 180.0)),
                       32+(int)(17*sin((hour()%12*30+minute()/2.0-90) *  M_PI / 180.0)));
  lcd.drawLine(31, 32, 31+(int)(25*cos(((minute()*6)-90) *  M_PI / 180.0)),
                       32+(int)(25*sin(((minute()*6)-90) *  M_PI / 180.0)));
  lcd.drawLine(31, 32, 31+(int)(27*cos(((second()*6)-90) *  M_PI / 180.0)),
                       32+(int)(27*sin(((second()*6)-90) *  M_PI / 180.0)));
  
  char buffer[50]; 
  sprintf(buffer, "%d.", day());  
  lcd.drawString(65, 12, daysS[weekday()-1]);
  lcd.drawString(65, 22, buffer);
  lcd.drawString(65, 32, monthS[month()-1]);
  sprintf(buffer, "%d", year());  
  lcd.drawString(65, 42, buffer);
  lcd.show();
}


