#include "Display.h"
#include "SPI.h"

/****************Scope Settings*****************/
// Zeige Messspeicher für X ms an
word store = 200;

// Pixelbreite der Signaldarstellung
byte focus = 2;

// Signalverschiebung in y-Richtung
byte yPos = 10;

// Zeitbasis - Prescaler ADC - Werte von 0-7 / Prescaler(1, 2, 4, 8, 16, 32, 64, 128)
byte time = 2;

// Signalstärke über Division des ADC Wertes (/2^volts)
byte volts = 5;

Display lcd = Display();
byte values[128] = {};

void setup() {
  //Testpoint
  pinMode(3, OUTPUT);
  TCCR2A = _BV(COM2B1) | _BV(WGM21) | _BV(WGM20);
  TCCR2B = 0<<CS22 | (1<<CS21) | (1<<CS20);
  OCR2B = 128;
  
  ADCSRA &= ~7;
  ADCSRA |= time;
  lcd.init(20);
  pinMode(A0, INPUT);
}

void loop() {
  delay(store);
  lcd.clearVideoBuffer();
  for (byte x=0; x<128; x++) {
    values[x] = (analogRead(A0) >> volts) + yPos;
  }
  for (byte x=0; x<128; x++) {
    for (byte p=0; p<focus; p++) {
      lcd.drawPixel(x, 64-values[x] - p + 1);
    }
  }
  lcd.show();
}

